#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <netdb.h>
#define INVALID_SOCKET -1
#define SOCKET_ERROR -1
#define NAME argv[1]
#define PORT argv[2]
typedef int SOCKET;
typedef struct sockaddr_in SOCKADDR_IN;
typedef struct sockaddr SOCKADDR;
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main (int argc, char* argv[])
{
  if (argc != 4 ) {
    printf("error arg : HostName Port Message\n");
    exit(-1);
  }

  struct hostent *hp;

  // Recuperation adresse 
  hp = gethostbyname(NAME);
  if (hp == NULL)
	{
		perror("client");
		return -1;
  }
   /* Creation de la socket sur le domaine internet */
   SOCKET sock = socket (AF_INET, SOCK_DGRAM, 0);
   if (sock != INVALID_SOCKET)
   {
      struct sockaddr_in si_client = { 0 };

      /* Initialisation de la structure contenant l'adresse de
         l'hote et le port utilise */
      si_client.sin_family = AF_INET;

      /* conversion du numero de port */
      si_client.sin_port = htons (atoi(PORT));

      /* conversion de l'adresse ip */
      memcpy(&si_client.sin_addr.s_addr, hp->h_addr, hp->h_length);

      printf ("bound to %s:%d\n", inet_ntoa(si_client.sin_addr), atoi(PORT));

      /* Envoi du message */
      const char *message = argv[3];
      int nb_octet = sendto (sock, message, strlen (message), 0,
                             (struct sockaddr *) &si_client,
                             sizeof (si_client));

      if (nb_octet > 0)
      {
         printf ("%d octets sent\n", nb_octet);

         {
            char data[128];
            int size_info_socket = sizeof (si_client);
            int nb_octet = recvfrom (sock, data, sizeof data - 1, 0,
                                     (struct sockaddr *) &si_client,
                                     &size_info_socket);

            if (nb_octet > 0)
            {
               printf ("%d octets received\n", nb_octet);
               data[nb_octet] = 0;
               printf ("< '%s'\n", data);
            }
            else if (nb_octet < 0)
            {
               printf ("recvfrom() : local error\n");
            }
            else
            {
               printf ("recvfrom() : remote error\n");
            }
         }
      }
      else if (nb_octet < 0)
      {
         printf ("sendto() : local error\n");
      }
      else
      {
         printf ("sendto() : remote error\n");
      }

      /* Fermeture de la socket */
      (void) close(sock);
   }
   else
   {
      printf ("socket() error\n");
   }

   return 0;
}

