#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>

int main (int argc, char* argv[]) {
  struct sockaddr_in sock_add;
  int client;
  int size_sock_add;
  char chaine[40];
  int i,l,longtxt;
  struct hostent* hp;

  if (argc != 4 ) {
    printf("error arg : HostName Port Message\n");
    exit(-1);
  }

  // Recuperation adresse 
  hp = gethostbyname(argv[1]);
  if (hp == NULL)
	{
		perror("client");
		return -1;
  }

  size_sock_add=sizeof(struct sockaddr_in);
  sock_add.sin_family = AF_INET;
  sock_add.sin_port = htons(atoi(argv[2]));
  memcpy(&sock_add.sin_addr.s_addr, hp->h_addr, hp->h_length);

	if ( (client=socket(AF_INET, SOCK_DGRAM,0))==-1)
	{
		perror("error socket");
		exit(-1);
	}
	// Envoi message
  const char *message = argv[3];
  int nb_octet = sendto (sock, message, strlen (message), 0,
                         (struct sockaddr *) &si_client,
                         sizeof (si_client));

  if (nb_octet > 0)
  {
     printf ("%d octets sent\n", nb_octet);
     {
        char data[128];
        int size_info_socket = sizeof (si_client);
        int nb_octet = recvfrom (sock, data, sizeof data - 1, 0,
                                 (struct sockaddr *) &si_client,
                                 &size_info_socket);
        if (nb_octet > 0)
        {
           printf ("%d octets received\n", nb_octet);
           data[nb_octet] = 0;
           printf ("< '%s'\n", data);
        }
        else if (nb_octet < 0)
        {
           printf ("recvfrom() : local error\n");
        }
        else
        {
           printf ("recvfrom() : remote error\n");
        }
     }
  }
  else if (nb_octet < 0)
  {
     printf ("sendto() : local error\n");
  }
  else
  {
     printf ("sendto() : remote error\n");
  }
  // Fermeture socket
  (void) closesocket (sock);

	return 0;
}

